//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>

#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
float f[100][100];
float d=0.15;
int pg[600],pd[600];
float Scale=25;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

void __fastcall TForm1::DDA_Method(float x0, float y0, float x1, float y1)
{
 float m;
 int dx,dy;
  if (int(x1+0.5)==int(x0+0.5))
   for (int i=y0; i<=y1; i++)
   {
    if (i>pg[int(x0+0.5)]) { Canvas->Pixels[x0][i]=clBlue; pg[int(x0+0.5)]=i; }
    if (i<pd[int(x0+0.5)]) { Canvas->Pixels[x0][i]=clRed; pd[int(x0+0.5)]=i; }
   }
  else
  if (int(y0+0.5)==int(y1+0.5))
  for (int i=x0; i<=x1; i++)
  {
   if (y0>pg[i]) { Canvas->Pixels[i][y0]=clBlue; pg[i]=y0; }
   if (y0<pd[i]) { Canvas->Pixels[i][y0]=clRed; pd[i]=y0; }
  }
  else
  {
   m=(y1-y0)/(x1-x0);
   if (fabs(m)<=1)
   {
    x0=int(x0+0.5);
    x1=int(x1+0.5);
    m=(y1-y0)/(x1-x0);
    if (x1>x0) dx=1; else dx=-1;
    while (x0!=x1)
    {
     if ((y0+0.5)>pg[int(x0+0.5)]) { Canvas->Pixels[x0][y0+0.5]=clBlue; pg[int(x0+0.5)]=(y0+0.5); }
     if ((y0+0.5)<pd[int(x0+0.5)]) { Canvas->Pixels[x0][y0+0.5]=clRed; pd[int(x0+0.5)]=(y0+0.5); }
     x0+=dx;
     y0+=dx*m;
    }
   }
   else
   {
    y0=int(y0+0.5);
    y1=int(y1+0.5);
    m=(x1-x0)/(y1-y0);
    if (y1>y0) dy=1; else dy=-1;
    while (y0!=y1)
    {
     if (y0>pg[int(x0+0.5)]) { Canvas->Pixels[x0+0.5][y0]=clBlue; pg[int(x0+0.5)]=y0; }
     if (y0<pd[int(x0+0.5)]) { Canvas->Pixels[x0+0.5][y0]=clRed; pd[int(x0+0.5)]=y0; }
     y0+=dy;
     x0+=dy*m;
    }
   }
  }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::CalcIzo(float x, float y, float z, float &x1, float &y1)
{
 float L1=0.5;
 float fi=45*M_PI/180;
 x1=x+L1*cos(fi)*z;
 y1=y+L1*sin(fi)*z;
 x1=Scale*x1+300+0.5;
 y1=200-Scale*y1+0.5;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
 float x,y;
 for (int i=0; i<100; i++)
  for (int j=0; j<100; j++)
  {
   x=(i-50)*d;
   y=(j-50)*d;
   f[i][j]=3*sin(sqrt(x*x+y*y));
  }
 DoubleBuffered=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
 int i,j,k;
 float x,y,x0,y0;
 for (i=0; i<600; i++)
 {
  pg[i]=0;
  pd[i]=400;
 }


// DrawBox();
 CalcIzo(-50*d,f[0][0],-50*d,x0,y0);
 for (i=1; i<100; i++)
 {
  CalcIzo((i-50)*d,f[i][0],-50*d,x,y);
  DDA_Method(x0,y0,x,y);
  x0=x; y0=y;
 }
 CalcIzo(49*d,f[99][0],-50*d,x0,y0);
 for (j=1; j<100; j++)
 {
  CalcIzo(49*d,f[99][j],(j-50)*d,x,y);
  DDA_Method(x0,y0,x,y);
  x0=x; y0=y;
 }

 for (j=0; j<99; j++)
 {
  for (i=2; i<100; i++)
  {
   CalcIzo((i-50)*d,f[i][j],(j-50)*d,x0,y0);
   CalcIzo((i-50)*d,f[i][j+1],(j-49)*d,x,y);
   DDA_Method(x0,y0,x,y);
  }
  for (i=2; i<99; i++)
  {
   CalcIzo((i-50)*d,f[i][j+1],(j-49)*d,x0,y0);
   CalcIzo((i-49)*d,f[i+1][j+1],(j-49)*d,x,y);
   DDA_Method(x0,y0,x,y);
  }
 }

/*
  for (k=1; k<100; k++)
  {
   for (i=0; i<99; i++)
    CalcIzo((i-50)*d,f[i][k],-50*d,x0,y0);
    CalcIzo((i-49)*d,f[i+1][k],-50*d,x,y);
    DDA_Method(x0,y0,x,y);
//   CalcIzo((49-k)*d,f[99-k][i],(i-50)*d,x0,y0);
//   CalcIzo((49-k)*d,f[99-k][i+1],(i-49)*d,x,y);
//   DDA_Method(x0,y0,x,y);
  }
*/
/*
 for (k=1; k<100; k++)
 {
  CalcIzo(-50*d,f[0][k],-50*d,x0,y0);
  for (i=1; i<100; i++)
  {
   CalcIzo((i-50)*d,f[i][k],-50*d,x,y);
   DDA_Method(x0,y0,x,y);
   x0=x; y0=y;
  }
  CalcIzo((49-k)*d,f[99-k][0],-50*d,x0,y0);
  for (j=1; j<100; j++)
  {
   CalcIzo((49-k)*d,f[99-k][j],(j-50)*d,x,y);
   DDA_Method(x0,y0,x,y);
   x0=x; y0=y;
  }
 }
*/
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
 Scale=ScrollBar1->Position;
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
 d=float(ScrollBar2->Position)/100.0;
 float x,y;
 for (int i=0; i<100; i++)
  for (int j=0; j<100; j++)
  {
   x=(i-50)*d;
   y=(j-50)*d;
   f[i][j]=ScrollBar3->Position*sin(sqrt(x*x+y*y));
  }
 Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar3Change(TObject *Sender)
{
 float x,y;
 for (int i=0; i<100; i++)
  for (int j=0; j<100; j++)
  {
   x=(i-50)*d;
   y=(j-50)*d;
   f[i][j]=ScrollBar3->Position*sin(sqrt(x*x+y*y));
  }
 Invalidate();
}
//---------------------------------------------------------------------------
